VERSION 5.00
Begin VB.Form frmBrightness 
   AutoRedraw      =   -1  'True
   Caption         =   "Tanner's Brightness Example"
   ClientHeight    =   5565
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6285
   LinkTopic       =   "Form1"
   ScaleHeight     =   371
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   419
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TxtBrightness 
      Height          =   285
      Left            =   4800
      TabIndex        =   2
      Text            =   "150"
      Top             =   5040
      Width           =   495
   End
   Begin VB.CommandButton CmdBrightness 
      Caption         =   "Change Brightness"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   4920
      Width           =   2895
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   4560
      Left            =   120
      Picture         =   "Brightness.frx":0000
      ScaleHeight     =   300
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   400
      TabIndex        =   0
      Top             =   120
      Width           =   6060
   End
   Begin VB.Label Label1 
      Caption         =   "Brightness Change (%):"
      Height          =   255
      Left            =   3120
      TabIndex        =   3
      Top             =   5040
      Width           =   1695
   End
End
Attribute VB_Name = "frmBrightness"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Brightness example by Tanner Helland

'Here's one way to flawlessly adjust a picture's brightness based on
'a percent value.  The code is pretty straight-forward, but if you
'have any questions feel free to send a message to
'tannerhelland@hotmail.com

'If you're eager for more graphics code, I'll be posting similar
'graphic filters and functions (blur, sharpen, contrast, transparency
'etc.) over the next couple weeks, so stay posted (if you have any
'filters and/or color functions you want to see done, I probably have
'it built already, just mail me).

'The CG graphic in the picture box is 1998 by SquareSoft
'(it's from Final Fantasy 8, if you care)

'The Windows API sets and gets pixels a whole lot faster then PSet
'and Point. The format is Picturebox.hdc, destination x, destination_
'y, color to set
Private Declare Function SetPixelV Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Byte
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long

Private Sub CmdBrightness_Click()
'variables for brightness, color calculation, positioning
Dim Brightness As Single
Dim NewColor As Long
Dim x, y As Integer
Dim r, g, b As Integer
'change the brightness to a percent
Brightness = TxtBrightness / 100
'run a loop through the picture to change every pixel
For x = 0 To Picture1.ScaleWidth
For y = 0 To Picture1.ScaleHeight
'get the current color value
NewColor = GetPixel(Picture1.hDC, x, y)
'extract the R,G,B values from the long returned by GetPixel
r = (NewColor Mod 256)
b = (Int(NewColor / 65536))
g = ((NewColor - (b * 65536) - r) / 256)
'change the RGB settings to their appropriate brightness
r = r * Brightness
b = b * Brightness
g = g * Brightness
'make sure the new variables aren't too high or too low
If r > 255 Then r = 255
If r < 0 Then r = 0
If b > 255 Then b = 255
If b < 0 Then b = 0
If g > 255 Then g = 255
If g < 0 Then g = 0
'set the new pixel
SetPixelV Picture1.hDC, x, y, RGB(r, g, b)
'continue through the loop
Next y
'refresh the picture box every 10 lines (a nice progress bar effect)
If x Mod 10 = 0 Then Picture1.Refresh
Next x
'final picture refresh
Picture1.Refresh
End Sub
